Commodore Amiga Reading HD 1.76MB ADF Images.
The HD ID signal that flashfloppy generates 101010... is not synced to the motor signal as it should be. This is because standard gotek doesn't have the motor signal connected. Usually we get away with it but perhaps not at boot.

This is possibly fixable if you hardware mod the gotek to connect the motor signal through. 
Have you tried a double reset? Ie reset after failing to boot from the floppy. Or reset and then reselect disk image before the boot process gets as far as checking the floppy for boot? 
Yes I have tried a double reset and I get the same result.<br>It gets stuck between track 0 and 1 and then boots from the hard-drive.<br><br>Why would a hardware mod be necessary?<br>Could that be emulated in a firmware fix?<br>If a hardware mod is the only solution, could you provide a circuit diagram?<br><br>Thankyou...
The issue is that the ID is sent on the READY signal wire when the motor is off, and select line is toggled. 1, 0, 1, 0, etc. But it has to be in sync at the start, as 0, 1, 0, 1, etc is a different ID! The start is signalled by the Amiga turning the floppy motor on and then off again. We miss that, and trust to blind luck that we are in sync with the Amiga's expectations (a 50/50 shot that actually we seem to always win, except in this case here).

Why does it work via AUTOBOOT? Probably because this looks like a disk-change at boot time.

So: 
1. Does a 1.76MB image boot from power on?
2. If you eject the 1.76MB image (do you have a rotary encoder? Just press it), reset, and then *immediately* re-insert the image (press the encoder again) does that boot?

And yes, in short you would need a hardware mod (here: https://github.com/keirf/FlashFloppy/wiki/Hardware-Mods#motor-signal) **and** you would need a tricky little firmware fix too. So that approach is not straightforward.
If you are interested in doing it properly, with the hardware mod, let me know and I can send you firmware(s) to test.
The 1.76MB image does not boot from power on.<br>I have a rotary encoder and when I press it to eject and then reinsert, nothing seems to happen.<br>It's only when I do a disk change through the Autoboot program then it boots.<br><br>It's not a huge concern. I was creating a custom install disk with the PFS3 file system on it. I ran out of space so I created a 1.76MB floppy version to make things a little easier.<br>I am getting the new Kickstart 3.X upgrade rom and I have to reinstall the operating system onto a new SD card.<br><br>I don't mind going through the AutoBoot program to do a disk change. It's just a little inconvenient.<br><br>Thanks for your help...
OK no problem. Reopen if you want to pursue it in future. 
> If you are interested in doing it properly, with the hardware mod, let me know and I can send you firmware(s) to test.

Hi,

I have an Amiga 4000 with modified Gotek drive (like described here  https://github.com/keirf/FlashFloppy/wiki/Hardware-Mods#motor-signal). Sometimes it work and sometimes not when I start theAmiga with an HD floppy drive inserted.
So I'm ok to do some tests with an alternative firmware. Just let me know if it's still good for you.
OK I will investigate this some more and get back to you. 
I just stubled at that topic. Was trying to use a HD Disk for booting some experimental WB. Made an HD Image, made install df0: on amiga, then copied a WB to it. I think it booted straight to it but maybe (i forgot) I needed some tries?! 
When booted I installed some grafic card drivers on that WB, rebooted and so far I could not get it to boot again :(

EDIT: Insert a normal DD Boot disk, enter the Boot menu, select DF0:, press boot and swap image to HD works.

Another thing I want to mention: After trying to boot a HD Image FlashFLoppy does not work anymore, I can switch images but they never appear on WB or the system. Even normal DD ones not.
@gbouille (and others) still any interest in pursuing this? Sorry for the years delay!!
Hi @keirf ,
It was a long time :)
Yes I'm still interested by this feature. 
And don't worry about the delay, I was not as available as I wish. 
Thanks ! 
Just a quick question related to this issue, in the hardware mods wiki, about Motor Signal mod, the mod specifically describes to connect pin 36 of the MCU to pin 16 of the floppy interface, while on the gotek bug fixes list, concerning the MotorON Signal, it is said that PA15, which is instead pin50 of the MCU, should be connected to pin 16 of the floppy interface, is it a typo or both MCU pins must be connected to pin16 of the floppy interface?
For a regular Gotek it is PB15 (pin 36 on an LQFP64 package). PA15 = pin 50 is only for Enhanced Gotek designs, identifying themselves as such to firmware via ID on pins PC12-15.

These days it is easier to get a new AT32F435 based Gotek which have Motor signal jumper configurable.
I have moved the Enhanced Gotek stuff to a separate support wiki page. It was confusing having it as a section within user Hardware Mods.
Thanks I modified my regular gotek with motor_on signal using your instructions and pin 36 for quite some time, to use it as HD floppy in my A4000, it is configured as Amiga under FF.cfg also the motor delay is set to 200ms in the cfg file. Still I also experience the behavior described above, amigatest kit describes the HD ID signal as unstable and it complains about a too fast ready signal switch between motoron and ready. I hope I explained it well enough. Is there the need of a custom firmware still?
Yes, the correct integration of Motor handling into generation of the HD disk ID signal is yet to be completed.
The too-fast READY signal warning means that the motor signal is somehow not configured correctly. Wrong option name in FF.CFG, or not correctly connected to pin 36, or not pulled up by a 1k resistor.
The 1k pull-up is correctly connected to pin 16 of the floppy interface and +5V line, so it is the wire to pin 36 of the MCU, just checked with multimeter. In FF.cfg I modified interface = amiga and motor-delay = 200, is there anything else needed? Flash floppy 3.35 installed ofc
Ok just tested: with interface = JC or shugart, motor signal works perfectly with 200ms delay to ready signal, it does not work with interface = amiga, In that case HD ID signal works but not motor-delay. Sorry I did not understand that it was not implemented at all if the interface is set to amiga, I thought it was still working simply not properly. Thanks and sorry
Please can you try this test firmware (you will need to be logged into GitHub for the link to work). Please make sure `interface = amiga` and `motor-delay = 200` in your FF.CFG.

You should find that the 200ms delay works properly. Also hopefully you will find that the HD ID stream is stable and correct.

https://github.com/keirf/flashfloppy/suites/8142113998/artifacts/353073025

Yep, it does work! 200ms motor signal to ready delay and no more unstable id! Do you need any more tests performed? My floppy config is: Gotek as HD Drive as DF0 and a regular DD amiga floppy as DF1, both internal on the same cable.
Can you give it a kick around on actual amigados, with/without using autoboot, inserted from cold boot, not inserted from cold boot, disk swaps within Workbench etc etc and see if it seems solid?
OK I got AmigaOS 3.2 Rom installed:

1. power on, No disks inserted -> Insert disk Logo on screen -> insert booting DD ADF -> working boot!
2. power on, booting DD ADF inserted -> working boot!
3. power on, booting DD disk DF1, not booting HD ADF in DF0 -> working boot -> able to browse HD ADF contents
4. power on, booting HDD, not booting DD ADF inserted, not booting DF1 disk inserted -> working HDD boot, able to browse both disks contents
5. In workbench with inserted DD adf on DF0: -> switch to HD adf on DF0: without eject-> able to browse HD ADF contents

I have yet to try a booting HD adf but other tests look ok.
I will let you know booting HD ADF results
Thanks

That's great! Thanks for your testing so far.
Ok, no problems whatsoever, but it does not boot from HD ADF, sometime it does but it's due to the fact that the Amiga still thinks it is a DD ADF. Let me explain: you power on the Amiga with not booting DD ADF inserted, Amiga goes to insert disk logo, then you switch to a Booting HD ADF without ejecting, the Amiga starts to boot but than complains about blocks out of range. I can replicate this every time. At the same time if  I go to Early Startup with a HD ADF mounted since power on, DF0 is not even listed as a boot device only DF1 is there, if I do the same but with DD ADF inserted both drives are present in the early startup boot selection. Quick question: can Amiga boots from HD floppies? A real HD FDD with a booting HD floppy inserted I mean. I can't test it, I got no HD FDD.
How odd. I think HD disks can be booted, though I've never tried myself.

Was this from power on? Is the behaviour the same if you mount an HD ADF and then C-A-A reset?

And is the overall amigados behaviour strictly better than previously? 

EDIT: There is also some small possibility this is an HD boot issue specific to Kickstart 3.2. Boot detection of df0 was changed in this Kickstart release.
The overall behavior is better, even more when, while in WBench, you switch from DD to HD ADF, it works no problem, probably the ID signal is working better. However if you boot to HDD with an HD ADF inserted since poweron/CTRL+A+A the DF0 drive does not work at all. This happens with cold boot and CTRL+A+A both.
I could disassemble 3.2 I suppose and see what it does at boot. 

It's weird it would be reliable everywhere except at boot, assuming 3.2 recognises HD disks at boot, which isn't confirmed.
Which Kickstart version are you running? 3.2 or 3.2.1?
3.2 but I can flash whatever version you want to test, no problem. I got official 3.2 and 3.1 original roms. Let me know.
A play around with 3.1 would be interesting. The boot time drive detection is definitely different in 3.1. More like earlier ROMs. Hyperion gave it perhaps the first big change / rewrite ever in 3.2.

If you have time. 

I also could do some testing. I'd need to make a bootable HD ADF.
I can switch the gotek to my Amiga 500 with KS2.04 or to my Amiga 1200 with KS 3.0 or 3.1 it does not require much work/time. If it still counts as a functional test for you. 
Yes still useful!
I disassembled KS 3.2.1 but nothing jumped out at me as being obviously different or wrong for boot time DF0. 
Hopefully others will do some before vs after testing too. It would be nice to put these changes in the next release if they don't regress anything and are of wider benefit. The comment here linking to the test firmware and instructions to make use of it is: https://github.com/keirf/flashfloppy/issues/354#issuecomment-1237316838
Note that you will need MOTOR signal hooked up: either using an AT32F435 Gotek, or will require solder modding of most old Gotek models.
Tested on KS3.0 A1200  same issue, WinUAE boots from HD floppies though, so probably does a real Amiga, using Amiga Test KIT on WinUAE with HD adf I get 377 ms motor-delay and 386 ms index pulses period, which is not exactly double the value of DD adf, which is 204 ms. Do you think it might be related? 
I'm going to try and obtain a real Amiga HD drive Chinon F[BZ]-357A and then I can do real-world side-by-side comparisons. I can't really understand why boot time behaves differently, especially warm reboot. Perhaps the FlashFloppy fix is still a bit racey.

Are your 1200 or 4000 accelerated at all?

386ms index pulses period is strange. I suspect a WinUAE bug.
In PCFloppy2Amiga.lha on aminet (which you probably already know perfectly well) there is this timing schema:
If there is a HD disk in the drive it will not pull the READY line low the second time the SELECT line is
low. For every even pulse on the SELECT line no READY pulse is given. In a time
diagram it looks like this:

SELECT  ~~~~~~|__|~~~~~~|__|~~~~~~|__|~~~~~~|__|~~~~~ amiga signal

READY   ~~~~~~|__|~~~~~~~~~~~~~~|__|~~~~~~~~~~~~~~~ signal from drive

and this note: For a High density drive to work with the amiga you need at least a kickstart
37.175 (2.0). There is however a bug only in the 37.175 kickstart. When you used
the HD drive with a DD floppy and you change it back for a HD floppy you will
still be in the DD mode so you will get a read error of the roottrack. The
program HDFixer in aminet archive disk/misc/HDFixer.lzh will remove this bug.
> I'm going to try and obtain a real Amiga HD drive Chinon F[BZ]-357A and then I can do real-world side-by-side comparisons. I can't really understand why boot time behaves differently, especially warm reboot. Perhaps the FlashFloppy fix is still a bit racey.
> 
> Are your 1200 or 4000 accelerated at all?
> 
> 386ms index pulses period is strange. I suspect a WinUAE bug.

My test a1200 is baremetal 68020 with only chip ram, my A4000 is warp engine accell with 68060 @ 75mhz and 128 MB fast 
Okay not related to acceleration then basically.

Regarding behaviour of READY signal -- yes, this is what the FF firmware fix is trying to improve emulation of. It's tricky in firmware as timing of responses to changes in the SELECT signal needs to be very fast. Maybe I'll find it works better anyway with the new 435-based Goteks (they are clocked 4x faster at 288MHz c.w. 72MHz on older Goteks). 

I can also put a logic analyser on the drive lines and check that READY is behaving as it should... just a case of finding some more time.
> Okay not related to acceleration then basically.
> 
> Regarding behaviour of READY signal -- yes, this is what the FF firmware fix is trying to improve emulation of. It's tricky in firmware as timing of responses to changes in the SELECT signal needs to be very fast. Maybe I'll find it works better anyway with the new 435-based Goteks (they are clocked 4x faster at 288MHz c.w. 72MHz on older Goteks).
> 
> I can also put a logic analyser on the drive lines and check that READY is behaving as it should... just a case of finding some more time.

Even if it is only at boot time, during os it works nicely, if needed I can connect an oscilloscope to SEL and READY lines to take a look at timings. 
there is also this note In PCFloppy2Amiga.lha:
The thing I didn't tell you that the amiga system isn't happy with testing the
READY line once no, to be on the save side it does it only 32 times.
Yes it reads in a 32-bit drive id. For no good reason really. Two bits would do: 11 no drive, 00 DD drive or HD drive DD disk, 10 HD drive HD disk, 01 40-track 5.25 drive.
This is described as the exact drive behaviour, probably timing relation between signals is quite important at boot time:
To recognize when a drive has been connected to the bus, there is a special drive identification mode.
A 32-bit word is read serially from the drive. To start this identification, the MTR line of the drive in question must be turned on and then off again (The description of the MTRX line tells how this is done). This resets the serial shift register in the drive. The individual data bits can then be read by placing the SELx line low and reading the value of the RDY as a data bit and then placing the SELx line high again. This process is repeated 32 times. The bit first received is the MSB (Most-Significant Bit) of the data word. Since the RDY line is active low, the data bits must be inverted.

The following are standard definitions for external drives:

$0000 0000 No drive connected (00)
$FFFF ffff Standard Amiga 3 1/2" drive (11)
$5555 5555 Amiga5 1/4" drive, 2x40 tracks (01)
As you can see, there are currently so few different identifications that it suffices to readjust the first two bits.

[A high capacity floppy drive was available for later Amigas, so this list may have been expanded for later models]

Most standard drives do not support this option.

As mentioned before, all of the lines except DRES affect only the drive selected. Originally the MTRX line was also independent of SELx, but the Amiga developers changed this by adding the motor flip-flop described on the [floppy disk interfacing](http://www.primrosebank.net/computers/amiga/upgrades/amiga_upgrades_storage_fd_int.htm) page.

MTRX | Normally this line causes all connected drives to turn their motors on, however, the Amiga has a flip-flop for each drive which takes on the value of the MTRX line whenever the SEL line for the given drive goes low. The output of the flip-flop is connected to the MTR line of the drive. This allows the drive motors to be turned on and off independently. For example, if the SEL0 line is placed low while the MTRX line is at 0, the motor on the internal floppy turns on. For the internal drive this flip-flop is on the motherboard. For each additional drive, an additional one is needed. On the 1010 disk drive Commodore placed this flip-flop on a small adapter board.

Sorry to bother you again Keirf, would be possible to have the regular flashfloppy firmware with just a simple addition? I need an output signal for when a DD or HD ADF is inserted, which I think is what you named in your ff.cfg: the dens,ndens signal. But I need it on a different pin which is not connected to pin 2 or pin 34 of the floppy interface. I would like to try and solve the ID problem at boot time with a simple and small logic board addition but I need a signal low when no adf  or a DD ADF are  inserted and a signal high when a HD ADF is inserted. If it works it should be possible to use the standard "interface=JC" or "interface=shugart" config with motor-delay set and the aforementioned DD/HD signal that could eventually be enabled  in FF.cfg.  In this way there would be no need to match the Amiga  timings with firmware and it could be used on every gotek old or new. Let me know what you think.
Here is a build which emits `den` signal on pin JB (speaker functionality is therefore disabled on this pin):
https://github.com/keirf/flashfloppy/suites/8169156486/artifacts/354965722
Ok, it works with the small logic board. Amigas boot from the hd ADF with no issue.
Some more work required on the firmware then!
> Some more work required on the firmware then!

This is the design I used as reference, based on how to modify a CHINON FB-357 to FB-357A. This is the pcb schematics to allow a FB-357 PC Drive to pass the correct ready signal for HD disks.

http://jope.fi/drives/fz357/CHINON1.JPG

Tested with FlashFloppy 3.35 interface=jc motor-delay=200 and a manual switch to choose DD/HD signal. I hope it helps.
Can you zip and attach a bootable HD ADF here for reference? 
https://aminet.net/package/disk/misc/Empty_ADF_files

You can find it inside this package on aminet. You can also create one using "install df0:" shell command with an empty HD ADF inserted in Gotek.



Sorry to bother you Kierf, I was trying to set dens/ndens signal to pin34 in FF.cfg to use it to supply the disk density info to the external pcb (in that way I can remove the manual switch) using regular flashfloppy 3.35 fw, but the custom settings of pin2 and pin34 in ff.cfg, seem to have no effects. Is it normal? Should I change something else? 
pin34 configuration won't work for interface=amiga. It should work for any other interface setting.
Hi Keirf,
Here is some info after a few tests.
On my configuration (A4000, stock A3640, kickstart version 46.143 (3.1.4)) with a gotek drive SFRC9220 I just can't boot with an HD drive nor use any HD image. The Workbench say "unreadable drive" (translate from french) when I select an HD image.
I used a logic analyser to capture some of the signal from the connector with a second real floppy drive to compare the ID negociation between the too.
The real drive is slightly more reactive than the Gotek (more or less 1 sample @4Mhz) but what is different is that the real disk drive does not change the DCHNG line during the negociation. The Gotek does.
The result is that the real drive is in the Select Boot Drive list in the early staurtup but not the Gotek drive.
Don't know if this is important.
I can send you an capture of the sequence (screenshot or pulseview file) if you want.
Yes please, traces with some explanation would be very illuminating for this boot time issue!
Inspecting more closely, the low to high transition of the RDY if a little late comparing to the real floppy drive. About 750 ns / 1 us. 
Attached is the Pulseview files with two drives (Gotek + real) with both HD floppies.
I've zoom on the ID negociation but you can see the full sequence (No boot, because no drive recognized for SD0 which is Gotek)
[HD cold boot sequence with two drives.zip](https://github.com/keirf/flashfloppy/files/9649264/HD.cold.boot.sequence.with.two.drives.zip)
After the ID negociation, the SEL0 signal is never pull down again. This is like the Amiga give up with this drive.
Late response is unavoidable because signal gating is managed in software. I assume you are using an STM32 or AT415 chip? New 435 Goteks should respond much faster (but still not as fast as a real drive).

Still it is presumably fast enough as HD identification seems to work apart from at boot?
No, the HD identification doesn't work at all. HD image are not recognise.
In the sequence, the RDY signal is shifted one pulse earlier with the gotek compared to the real drive. So I think the amiga see 010101 instead of 10101 (or the contrary) ?
And yes, this is a STM32 model.
If you're really interested to get better emulation you will need to hook up motor signal on your gotek. Or get a new 435 based gotek which is both faster and has motor signal jumperable. And then try the test firmware linked here about three weeks ago.
Another option is to work together to design an external circuit to generate ready signal properly, generate motor signal from mtrx, and gate signals on select signal in hardware.
External circuit works fine already, but the signal den/nden doesn't seems to work with Amiga ADF,    I always get a low signal with both DD or HD ADF inserted, so you have to switch manually the external circuit.
I've already mod the gotek with a 1k pullup resistor and connect the pin16 to pin 36 of STM32.
And the test I sent you is with the fimrware downloded from this discussion. The OLED says b559c92. Is it the last one ?
Motor signal delay is not really needed for HD ready signal to work, however the ready pulse timing  must be correctly in sync with the sel and motor signal from the Amiga
> I've already mod the gotek with a 1k pullup resistor and connect the pin16 to pin 36 of STM32. And the test I sent you is with the fimrware downloded from this discussion. The OLED says [b559c92](https://github.com/keirf/flashfloppy/commit/b559c921a2a59ee7c3b072060c7a8acf9ea8adf7). Is it the last one ?

Yes that's right. Did you also put the required settings in FF.CFG?
> External circuit works fine already, but the signal den/nden doesn't seems to work with Amiga ADF, I always get a low signal with both DD or HD ADF inserted, so you have to switch manually the external circuit.

From stock firmware? I could fix this. However den/nden are also gated on select input signal. For your external circuitry you might not want that.
I think this is the case  :
interface = amiga
pin02 = auto
pin34 = auto
motor-delay = 200
> signal

Well it would be great to have a single output pin:  signal low (0V) when a DD ADF is inserted and signal high (5V) when HD ADF is inserted. The external circuit would then work without manual switching. It even boots HD ADF, already tested with the manual switch.
> I think this is the case  :
> interface = amiga
> pin02 = auto
> pin34 = auto
> motor-delay = 200

Yes that's right. Perhaps the Gotek is just too slow to work reliably in all cases.  It does seem to be mostly working for Madowax. The new faster Gotek chip might work better but hard to know for sure. 
In my case your test firmware works great except for boot, but with the external circuit even the standard firmware works fine and it even boots, no need to use interface=Amiga or motor-delay in FF.cfg. The only thing missing is the density output signal from gotek to allow the external circuit to automatically switch the ready signal from DD to HD. 
> In my case your test firmware works great except for boot, but with the external circuit even the standard firmware works fine and it even boots, no need to use interface=Amiga or motor-delay in FF.cfg. The only thing missing is the density output signal from gotek to allow the external circuit to automatically switch the ready signal from DD to HD. 

Do you need the pin to output 0v when a DD ADF is inserted regardless of whether the drive is selected? Ie an ungated output? Also would it be okay if DD were 5v and HD 0v?
Yep ungated would be great, like the HD/DD hardware switch of many PC drives, if the floppy got the HD hole the switch is not pressed and if the floppy has no HD hole the switch is pressed, it is the same for me if the signal output is DD = 5V and HD = 0V. 
> Yep ungated would be great, like the HD/DD hardware switch of many PC drives, if the floppy got the HD hole the switch is not pressed and if the floppy has no HD hole the switch is pressed, it is the same for me if the signal output is DD = 5V and HD = 0V.

I should be able to rustle something up.
> No, the HD identification doesn't work at all. HD image are not recognise. In the sequence, the RDY signal is shifted one pulse earlier with the gotek compared to the real drive. So I think the amiga see 010101 instead of 10101 (or the contrary) ? And yes, this is a STM32 model.

Have you tested to see what ID Amiga Test Kit reads in its floppy subtest? Every time you enter the subtest menu, the floppy IDs are resampled and displayed.
> Yes that's right. Perhaps the Gotek is just too slow to work reliably in all cases. It does seem to be mostly working for Madowax. The new faster Gotek chip might work better but hard to know for sure.
What is strange, is that the RDY line of the Gotek seems to be one SEL0 pulse ahead compared to the real drive.
In this pictures you can see tha t the first pule of RDY line is "under" the first pulse of SEL for Gotek and the second pulse of SEL for the real drive. 
![Gotek response to SEL0-ann](https://user-images.githubusercontent.com/45919242/192510782-2719940b-827a-4856-b868-7bacbd0a8110.png)
![Real drive response to SEL1-ann](https://user-images.githubusercontent.com/45919242/192510784-5a7f34c0-2a02-45d4-a93d-08e91b945331.png)

Hmmmmm agreed. I will have to test this myself.
Okay here is a trace on my 435-based drive, using Amiga Test Kit (hence the SEL pulsing is much slower here, as ATK is written in unoptimised C, rather than the slick asm used for low-level Kickstart ROM routines). Click the picture to enlarge and make it legible.

![Untitled](https://user-images.githubusercontent.com/879766/192526897-72b701e1-2d91-4a64-9ccb-62aa82474f6c.png)

So what's happening here?
1. SEL and MTR both change at about the same time, because MTR is latched on SEL.
2. FlashFloppy SEL and MTR ISRs both fire. SEL is higher priority so it executes first. It wants to toggle RDY (because that is what normally happens as SEL is toggled when an HD disk is inserted). Hence RDY goes LOW.
3. MTR ISR runs second. It wants to reset the RDY ID sequence and so brings RDY HIGH.
4. After this everything runs happily in sync.

Why does this work for me? Apart from the SEL toggling being way slower, note that the RDY runt pulse is about 850ns wide. I estimate that the two ISRs take a total of about 1200ns to run from SEL being asserted. This would probably therefore work in your case too, since your worst-case SEL pulse width is about 1500ns.

But you are not running on a 435. STM32 and 415 chips are clocked at 72MHz, that's a quarter speed of the 435! Plus STM32 is executing out of slow Flash. There is prefetch, but branches and exceptions are more expensive. So the STM chip is running at less than quarter speed of the 435. So that total of 1200ns ISR latency on 435 is probably more like 5000ns on STM!

In short: STM is just too slow to implement this accurate (enough) HD ID emulation. You need to get yourself a faster Gotek :)

PS. As to why DSKCHG is asserted in your boot trace on Gotek. Do you have a trace from power on? Can you see where the drive heads are stepped and thus the drive should deassert DSKCHG? Perhaps the Gotek is too slow to boot and misses the head step? Perhaps 435 is faster or we can otherwise work on this...
Thank you for this detail explication.
So un real life, we have two choices :
- create an electronic adapter like the one Madowax has created and try to implement le HD/DD signal to have a fully usable one
- buy an 435 based gotek and recycle this good old STM in an A500 :)
So @Madowax , do you have a complete schematic of your external circuit ?
And @keirf , where can we buy such a 435 based model for sure ? I tried ebay for exemple and there is nowhere a mention of the exact model of the chip used... :/
> PS. As to why DSKCHG is asserted in your boot trace on Gotek. Do you have a trace from power on? Can you see where the drive heads are stepped and thus the drive should deassert DSKCHG? Perhaps the Gotek is too slow to boot and misses the head step? Perhaps 435 is faster or we can otherwise work on this...

Here are the traces for a full boot sequence with an DD image, two drives connected (Gotek + real).
The first one at the very beginning on power on (+5v is used as a trigger)
The second one approx. 3.4s after with the ID sequence and the same problem. It seems the the DCHNG signal his exactly the same as RDY. I think that 3.4s is enough for the gotek to boot, but let me know. 
Between the to traces no signals changes at all.
![DD boot sequence begining](https://user-images.githubusercontent.com/45919242/192588177-a8213fe3-153d-424c-aea6-12fadc568729.png)
![DD boot sequence ID](https://user-images.githubusercontent.com/45919242/192588174-f86ac53f-5213-48df-bd3c-97a8bea1fe5d.png)


>   And @keirf , where can we buy such a 435 based model for sure ? I tried ebay for exemple and there is nowhere a mention of the exact model of the chip used... :/

Well, I did honestly expect there would be more resellers by now. But you can get them from me directly. I am zeroflux on ebay uk. Or email me. I do 888 LED model for £28 and OLED + rotary model for £37. Plus postage.

> Here are the traces for a full boot sequence with an DD image, two drives connected (Gotek + real). The first one at the very beginning on power on (+5v is used as a trigger) The second one approx. 3.4s after with the ID sequence and the same problem. It seems the the DCHNG signal his exactly the same as RDY. I think that 3.4s is enough for the gotek to boot, but let me know. Between the to traces no signals changes at all.

DSKCHG looks like RDY because both are asserted (LOW). But they are gated on drive select. So of course they toggle together, in response to drive select.

I think it is normal for DSKCHG to be asserted at power on, even if a disk is inserted at power on. I have just confirmed this on drives made by NEC, Sony, and Teac.

The only thing that should deassert DSKCHG is a head step operation (ie a pulse on STEP while drive is SELected). If you do a trace from power on, is there any activity on STEP before the ID sequence?

Can you boot Amiga Test Kit and check DSKCHG behaviour in the floppy signal test? When you eject a disk from the real Amiga HD drive you should see CHG asserted. You should then see it deassert **only** after you insert a disk and then step the heads (action key F6). Some drives may instead deassert CHG after a second or two after inserting a disk. It would be interesting to know which behaviour the real Amiga HD drive exhibits.
> The only thing that should deassert DSKCHG is a head step operation (ie a pulse on STEP while drive is SELected). If you do a trace from power on, is there any activity on STEP before the ID sequence?

You're right, there is no step activity on power on until the first disk activity after the ID sequence.

> > The only thing that should deassert DSKCHG is a head step operation (ie a pulse on STEP while drive is SELected). If you do a trace from power on, is there any activity on STEP before the ID sequence?
> 
> You're right, there is no step activity on power on until the first disk activity after the ID sequence.

I do actually have an Amiga HD drive myself. I will find some time to do some experiments.
The only input signals needed are SEL0 and MTR0 from the amiga motherboard for the HD ready ID to work properly. If there is a HD ADF in the drive it should not pull the READY line low the second time the SELECT line is low. For every even pulse on the SELECT line no READY pulse is given. Also an open drain output for the ready signal seems to be required since it is quite fast and it sinks quite a lot of current.
On reflection I'm pretty sure the boot time DSKCHG difference is a red herring. 
> On reflection I'm pretty sure the boot time DSKCHG difference is a red herring.

Furthermore, I plugged in my Amiga HD drive and as expected DSKCHG is not deasserted until after a head step operation. And DSKCHG is asserted at power on. So this whole DSKCHG thing probably really is a diversion.
Hi Keirf,
I can confirm that this is only a timing issue. The delay between SEL0 and RDY must be really short the allow the Amiga to detect the right value on RDY.
My CHINON FB-357A as not the same behaviour than the Gotek regarding DSKCHG on power on but this change nothing for the boot sequence. I suceeded to boot from Gotek with HD floppy and a little external circuit (certainly the same as Madowax).
So I conclude that the STM Gotek model will never be fast enough to support HD floppy for Amiga. If this work, this is only kind of luck and not reliable.
For the external circuit to be autonomous, it needs to have a signal to know the density of the floppy disk. In my version, DD=0, HD=1 (5v) but can be change easely.
Do you have a link or reference for the external circuit?
> Do you have a link or reference for the external circuit?

http://jope.fi/drives/fz357/CHINON1.JPG

Reference circuit for Chinon, it works every time with gotek. I have designed a little pcb that can be directly soldered on gotek floppy header using this reference. 

The pull down resistor at pin 6 is a bit weird. I suppose maybe that's to work with drives with no HD capability and no output on that pin? 

I propose a new interface=shugart-amigaden which would put permanent /DD output on pin JC. Pin 34 would work as regular Shugart. JC would be open collector and require a pull up rather than pull down.
That's exactly what I've done.
Based on your Schema, MadoWax and changed the pull down with an 1k pull up. Work every time. /DD open for HD and connected to ground for a DD.
Kerif, your proposition sound good. 
Madowax can you share your PCB design ?
The pull down was there for when the Chinon had no floppy inserted, so the pull down resistor would pull the signal down and force a DD ready ID. it is not needed with a manual switch or it could be inverted to pull up with your proposed open collector output on JC, pin 34 can also be configured as none in FF.cfg since the ready signal would be completely handed to the external pcb. So if you need that pull up resistor I will modify the schematics and post them here for your approval, is it ok for you?


The alternative is to put the density signal on pin 34, rather than JC. I did wonder though if alternative designs might want to use RDY on pin34 when motor is on.
This is designed to slide and be soldered directly on the gotek floppy pin header, you just have to remove the pin header black spacer rows, the board will replace them and keep together the pin header. the whole board is 1,5 cm high and I can still shave off a couple of millimeters.
 
![rev0002(7408+7406+7474)top](https://user-images.githubusercontent.com/112888894/193440248-c32c71d4-dd50-48f7-821e-a293335d5def.png)
![rev0002(7408+7406+7474)bot](https://user-images.githubusercontent.com/112888894/193441223-71dbdd1e-a728-48b9-a457-b8bda588676d.png)



> The alternative is to put the density signal on pin 34, rather than JC. I did wonder though if alternative designs might want to use RDY on pin34 when motor is on.

I prefer to not change the behaviour of pin34. My design pick the signals from the gotek PCB and I prefer not to desolder the floppy cable header. So the way it work with pin34 is fine.
With /DD signal on pin34 the external circuit as to be between the gotek and the ribbon cable.
Maybe an option ?
> > The alternative is to put the density signal on pin 34, rather than JC. I did wonder though if alternative designs might want to use RDY on pin34 when motor is on.
> 
> I prefer to not change the behaviour of pin34. My design pick the signals from the gotek PCB and I prefer not to desolder the floppy cable header. So the way it work with pin34 is fine. With /DD signal on pin34 the external circuit as to be between the gotek and the ribbon cable. Maybe an option ?

Maybe I did not explain myself, there is no need to desolder anything with my pcb, you can also keep the pin 34 behavior and not change it, it works nevertheless. You just solder the PCB on the header without desoldering or anything. 
> > > The alternative is to put the density signal on pin 34, rather than JC. I did wonder though if alternative designs might want to use RDY on pin34 when motor is on.
> > 
> > 
> > I prefer to not change the behaviour of pin34. My design pick the signals from the gotek PCB and I prefer not to desolder the floppy cable header. So the way it work with pin34 is fine. With /DD signal on pin34 the external circuit as to be between the gotek and the ribbon cable. Maybe an option ?
> 
> Maybe I did not explain myself, there is no need to desolder anything with my pcb, you can also keep the pin 34 behavior and not change it, it works nevertheless. You just solder the PCB on the header without desoldering or anything.

Sorry, I juste understand :) :
You just have to remove the black plastic and slide the PCB as far as possible and solder it. Good idea !
I just wonder why you need 3 ICs on your solution ?
@Madowax does your Gotek have the JC jumper position? (ie. just to confirm it is not an old SFRKC30.AT2 board)?
> > > > The alternative is to put the density signal on pin 34, rather than JC. I did wonder though if alternative designs might want to use RDY on pin34 when motor is on.
> > > 
> > > 
> > > I prefer to not change the behaviour of pin34. My design pick the signals from the gotek PCB and I prefer not to desolder the floppy cable header. So the way it work with pin34 is fine. With /DD signal on pin34 the external circuit as to be between the gotek and the ribbon cable. Maybe an option ?
> > 
> > 
> > Maybe I did not explain myself, there is no need to desolder anything with my pcb, you can also keep the pin 34 behavior and not change it, it works nevertheless. You just solder the PCB on the header without desoldering or anything.
> 
> Sorry, I juste understand :) : You just have to remove the black plastic and slide the PCB as far as possible and solder it. Good idea ! I just wonder why you need 3 ICs on your solution ?

I choose to use 74hct08+7406 instead of a single 74ls38, it is more versatile if you just need to invert a signal without wasting a nand/and gate to do so. But it can be build with just two ICs with minor mods.
Okay, here is a new build with new features for `interface = amiga`:
1. The previous Amiga pin 34 behaviour is still enabled by default (ie. toggling when HD disk inserted, sync'ed to /MTR signal).
2. Above can be re-configured by for example `pin34 = rdy` to make pin 34 behave as Shugart.
3. JC now carries ungated open-collector /DD density signal.

Note that if you do want to completely ignore Gotek pin 34 output on your adapter, you will need to cut the pin. It seems to me you could do this after soldering your adapter board to all 34 pins. After this, simply cut pin 34 where it meets the Gotek PCB? It would then still be mechanically secured by its solder connection to the adapter board.

PS. You need to be logged into GitHub for the below link to work.
PPS. Note that signal JC is on the header row *furthest* from the JC text on the PCB. The pin right next to the text is GROUND!

https://github.com/keirf/flashfloppy/suites/8572573786/artifacts/383573937
Just tested with with my external circuit (not yet a PCB) and it worked just like expected :
`interface = amiga`
`pin34 = rdy`
Boot on HD floppy works
Boot on DD floppy works
Change between HD and DD in workbench is recognize as expected.
Great work !
Thx
> Just tested with with my external circuit (not yet a PCB) and it worked just like expected : `interface = amiga` `pin34 = rdy` Boot on HD floppy works Boot on DD floppy works Change between HD and DD in workbench is recognize as expected. Great work ! Thx

Excellent! Of course it will be interesting to know if a bare 435 Gotek works just as well with this build, when you receive it.
> Okay, here is a new build with new features for `interface = amiga`:
> 
> 1. The previous Amiga pin 34 behaviour is still enabled by default (ie. toggling when HD disk inserted, sync'ed to /MTR signal).
> 2. Above can be re-configured by for example `pin34 = rdy` to make pin 34 behave as Shugart.
> 3. JC now carries ungated open-collector /DD density signal.
> 
> Note that if you do want to completely ignore Gotek pin 34 output on your adapter, you will need to cut the pin. It seems to me you could do this after soldering your adapter board to all 34 pins. After this, simply cut pin 34 where it meets the Gotek PCB? It would then still be mechanically secured by its solder connection to the adapter board.
> 
> PS. You need to be logged into GitHub for the below link to work. PPS. Note that signal JC is on the header row _furthest_ from the JC text on the PCB. The pin right next to the text is GROUND!
> 



Yes that of cutting pin 34 after soldering the pcb  is also an option, I thought you could use pin 34 instead of JC for DD/HD signal, in that way you don't lose JC functionality. Btw my goteks are all stm32 SFR1M44-U100K, so they got JC jumper.
JC functionality is unimportant. Actually it selects IBMPC vs Shugart when `interface=jc` only. So it is available for other interface settings. And available for use with no further config setting: `interface=amiga` suffices.
Hi Keirf,
I received  the 435 version yesterday in good shape, no problem, thanks.
After a few test I found no problem with the last firmware version:
`interface=amiga
pin34=auto`
Boot from HD : OK
change in WB from HD to DD and from DD to HD : OK
It Seems it work great as expected.
Great news! This is the plain 435-based Gotek with no adapter board for generating the ID signal externally, right?

Yes, without modification except using MOR jumper configuration
> Yes, without modification except using MOR jumper configuration

Yes, and `motor-delay=200` (or similar) too of course?
Yes!
This is all fixed in v3.36 and the wiki updated. Case closed!
Reopen only because there is a small bug in MOTOR handling. When a disk is *not* inserted, changes in MOTOR input are currently ignored. Pin 34 will be set to opposite of MOTOR at time disk was ejected, up until next time a disk is inserted. Commonly this will mean Pin 34 is LOW, and this happens to mean a permanent DD-ID on pin 34 until disk is next inserted, and this will satisfy 99.9% of software I'm sure (there are a few games which I think use MTR toggling and RDY sampling to detect disk insertion, eg. Stardust).

So I should fix this since it's not hard. And then it would be good to have that fix tested, if interested folks on this ticket are happy to do so?
@gbouille (and others) could you try the following firmware please?

https://github.com/keirf/flashfloppy/suites/8835715192/artifacts/402639062
Should all be fixed now in v3.37